VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Google Maps API Signature Generator"
   ClientHeight    =   4470
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   10050
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4470
   ScaleWidth      =   10050
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   495
      Left            =   8700
      TabIndex        =   3
      Top             =   1440
      Width           =   1215
   End
   Begin VB.TextBox txtSignedURL 
      BackColor       =   &H8000000F&
      ForeColor       =   &H80000012&
      Height          =   735
      Left            =   2760
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   11
      TabStop         =   0   'False
      Top             =   3600
      Width           =   7215
   End
   Begin VB.TextBox txtMB64Signature 
      BackColor       =   &H8000000F&
      ForeColor       =   &H80000012&
      Height          =   375
      Left            =   2760
      Locked          =   -1  'True
      TabIndex        =   9
      TabStop         =   0   'False
      Top             =   3120
      Width           =   3615
   End
   Begin VB.TextBox txtPortionToSign 
      BackColor       =   &H8000000F&
      ForeColor       =   &H80000012&
      Height          =   735
      Left            =   2760
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   2280
      Width           =   7215
   End
   Begin VB.CommandButton cmdGenerate 
      Caption         =   "Generate"
      Height          =   495
      Left            =   2760
      TabIndex        =   2
      Top             =   1440
      Width           =   1215
   End
   Begin VB.TextBox txtPKMB64 
      Height          =   375
      Left            =   2760
      TabIndex        =   1
      Text            =   "vNIXE0xscrmjlyV-12Nj_BvUPaw="
      Top             =   960
      Width           =   3495
   End
   Begin VB.TextBox txtUrl 
      Height          =   735
      Left            =   2760
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   120
      Width           =   7215
   End
   Begin VB.Label Label5 
      Alignment       =   1  'Right Justify
      Caption         =   "Full Signed URL"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   3660
      Width           =   2595
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Signature (modified Base64)"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   3180
      Width           =   2595
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "URL Portion To Sign"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2340
      Width           =   2595
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Private Key (modified Base64)"
      Height          =   255
      Left            =   60
      TabIndex        =   5
      Top             =   1020
      Width           =   2595
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "URL"
      Height          =   255
      Left            =   60
      TabIndex        =   4
      Top             =   180
      Width           =   2595
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Example showing how to generate a Google Maps API Signature.
'
'The code here is verbose with named intermediate results
'to help illustrate the process.

Private Sub EnableGenerate()
    cmdGenerate.Enabled = Len(txtUrl.Text) > 0 And Len(txtPKMB64.Text) > 0
End Sub

Private Function GoogleUrlSigner(ByVal Url As String, ByVal PKeyMB64 As String) As String
    Dim PortionToSign As String
    Dim I As Long
    Dim Pos As Long
    Dim PKeyB64 As String
    Dim HS1 As HS1
    Dim PKey() As Byte
    Dim PortionToSignUtf8() As Byte
    Dim Signature() As Byte
    Dim B64Signature As String
    Dim MB64Signature As String
    
    PortionToSign = Url
    For I = 1 To 3
        Pos = InStr(Pos + 1, PortionToSign, "/")
        If Pos < 1 Then Err.Raise 5, "GoogleUrlSigner", "Bad URL"
    Next
    PortionToSign = Mid$(PortionToSign, Pos)
    txtPortionToSign.Text = PortionToSign 'This is just for testing.
    
    PKeyB64 = Replace$(Replace$(PKeyMB64, "_", "/"), "-", "+")
    Set HS1 = New HS1
    With HS1
        PKey = .Decode(PKeyB64, edfBase64)
        .InitHmac PKey
        PortionToSignUtf8 = .ToUTF8(PortionToSign)
        Signature = .HmacSha1(PortionToSignUtf8)
        B64Signature = .Encode(Signature, edfBase64)
        MB64Signature = Replace$(Replace$(B64Signature, "/", "_"), "+", "-")
        txtMB64Signature.Text = MB64Signature 'This is just for testing.
    End With
    
    GoogleUrlSigner = Url & "&signature=" & MB64Signature
End Function

Private Sub cmdGenerate_Click()
    Dim Url As String
    
    'Note: Since we're taking this from a multiline TextBox we'll
    'have to zap any extraneous newlines.  This is not part of
    'the signature algorithm as such.
    Url = Replace$(Trim$(txtUrl.Text), vbNewLine, vbNullString)
    
    On Error Resume Next
    txtSignedURL.Text = GoogleUrlSigner(Url, Trim$(txtPKMB64.Text))
    If Err Then
        MsgBox "Error " & CStr(Err.Number) & " in " & Err.Source & vbNewLine & vbNewLine _
             & Err.Description
        txtUrl.SetFocus
    Else
        cmdReset.SetFocus
    End If
End Sub

Private Sub cmdReset_Click()
    txtUrl.Text = vbNullString
    txtPKMB64.Text = vbNullString
    txtPortionToSign.Text = ""
    txtMB64Signature.Text = vbNullString
    txtSignedURL.Text = vbNullString
    
    txtUrl.SetFocus
End Sub

Private Sub Form_Load()
    EnableGenerate
End Sub

Private Sub txtPKMB64_Change()
    EnableGenerate
End Sub

Private Sub txtUrl_Change()
    EnableGenerate
End Sub
